#include <array>
#include <iostream>

void print(const auto& arr) {
	for (auto& elem : arr) {
		std::cout << elem << ' ';
	}
	std::cout << '\n';
}

int main() {
	std::array a = { 1, 2, 3, 4, 5, 6, 7 };
	auto* ptr = &a[0];

	ptr += 7;  // this is OK
	// *ptr = 8;  // this is UB

	--ptr;
	*ptr = 8;

	print(a);
	std::cout << ptr[-3] << '\n';
}
