#include <memory>
#include <iostream>

struct thing {
	thing() { std::cout << "thing constructed\n"; }
	~thing() { std::cout << "thing destroyed\n"; }
};

struct node {
	thing value;
	std::shared_ptr<node> next;
};

int main() {
	auto n1 = std::make_shared<node>();
	auto n2 = std::make_shared<node>();
	n1->next = n2;
	n2->next = n1;
}
